<?php

///////////////////////////////////////////////////
// なんでも一覧自動生成プログラム　じぇねログ Ver0.1
// 製作者    ：ガタガタ
// サイト    ：https://do.gt-gt.org/
// ライセンス：MITライセンス
// 全文      ：https://ja.osdn.net/projects/opensource/wiki/licenses%2FMIT_license
// 公開日    ：2024.02.19
// このプログラムはどなたでも無償で利用・複製・変更・
// 再配布および複製物を販売することができます。
// ただし、上記著作権表示ならびに同意意志を、
// このファイルから削除しないでください。
///////////////////////////////////////////////////

header('Content-Type: text/html; charset=UTF-8');
setlocale(LC_ALL, 'ja_JP.UTF-8');

$include = get_included_files();
if (array_shift($include) === __FILE__) {
    die('このファイルへの直接のアクセスは禁止されています。');
}

class genelog {
    
    // コンストラクタ宣言
    public function __construct() {

      if( isset($_GET["page"])) {
        $this->genelog_page = $_GET["page"];
      } else {
        $this->genelog_page = '1';
      }

    }

    public function genelogCreateLogs($file, $perpage, $current, $temp) {
      list($data, $keys) = $this->getGenelogArray($file, $current);

      if($data === false) {
        return '<p>データの形式が誤っているようです。</p>';
      }
      
      if ($perpage < '-1') {
        echo 'ページあたりの表示件数の設定が間違っています。正の整数か、-1（全件表示）を設定してください。';
      } elseif (preg_match('/^0$|^-?[1-9][0-9]*$/', $perpage)) {

        $genelog_start = (($this->genelog_page - 1 ) * $perpage);
        $genelog_end = ($this->genelog_page * $perpage);

        if ($perpage == '-1') {
          $perpage = count($data);
          $genelog_start = 0;
          $genelog_end = $perpage;
        }

        for ($i = $genelog_start; $i < $genelog_end; $i++) { 
          $no0 = $i + 1;
          $no00 = str_pad($no0, 2, 0, STR_PAD_LEFT);
          $no000 = str_pad($no0, 3, 0, STR_PAD_LEFT);
          if(!key_exists($i, $data)) {
            continue;
          }
          $item = $data[$i];
          include('templates/'.$temp);
        }
      }

    }

    private function getGenelogArray($file, $current) {
      $rawDatas = array();
      
      if(is_array($file)) {
        // foreach ($file as $item) {
        //   $rawDatas = array_merge($rawDatas, $this->genelogGetDatas($item, $current));
        // }
        $rawDatas = $this->genelogGetDatas($file[0], $current);
      } else {
        $rawDatas = $this->genelogGetDatas($file, $current);
      }

      if(!$rawDatas || !key_exists(1, $rawDatas)) {
        return 'データがありません。';
      }
      
      $data = array();
      $keys = $rawDatas[0];

      for ($i=1; $i < count($rawDatas); $i++) { 
        $addArr = array();
        foreach ($keys as $key => $val) {
          $addArr[$val] = $rawDatas[$i][$key];
        }
        $data[] = $addArr;
      }

      if(is_array($file) && key_exists(1, $file)) {
        for ($i=1; $i < count($file); $i++) { 
          $rawDatas = $this->genelogGetDatas($file[$i], $current);
          $newKeys = $rawDatas[0];
          if($newKeys !== $keys) {
            return array(false, $keys);
          } else {

            for ($j=1; $j < count($rawDatas); $j++) { 
              $addArr = array();
              foreach ($keys as $key => $val) {
                $addArr[$val] = $rawDatas[$j][$key];
              }
              $data[] = $addArr;
            }
            
          }
        }
      }

      return array($data, $keys);

    }

      // csvを拾う関数
    private function genelogGetDatas($file, $current) {
      $csv = $current . '/'. $file;
      
      if(file_exists($csv)) {
        $fp = fopen($csv, "r");
        $csvArray = array();
  
        // CSVからデータを取得し二次元配列に変換する
        $row = 0;
        while( $ret_csv = fgetcsv( $fp, 0 ) ){
          for($col = 0; $col < count( $ret_csv ); $col++ ){
            $csvArray[$row][$col] = $ret_csv[$col];
          }
          $row++;
        }
        fclose($fp);

        return $csvArray;
      } else {
        return null;
      }
      
    }
      
        // ページネーションを出力する関数
        public function createGenelogPagenation($file, $perpage, $current) {
          // 全てを出力する設定であればここで処理を終わる
          if($perpage == '-1') {
            return;
          }
        list($data, $keys) = $this->getGenelogArray($file, $current);

        if($data === false) {
          return '<p>データの形式が誤っているようです。</p>';
        }  

        if (count($data) > $perpage) {
         $genelog_lastpage = ceil(count($data) / $perpage);
    
        ?>
  
        <ul class="genelog_pagination">
      
        <?php
  
        if ($this->genelog_page > '1') {
          ?>
          <li class="genelog_prev"><a href="?page=<?php echo $this->genelog_page - 1; ?>"></a></li>
          <li><a href="?page=1">1</a></li>
          <?php
        } elseif ($this->genelog_page = '1') {
          ?>
          <li class="current">1</li>
          <?php
        }
  
        if ($this->genelog_page >= '1' && $this->genelog_page <= $genelog_lastpage) {
          for ($i=-2; $i < 3; $i++) { 
            $check = $this->genelog_page + $i;
            if ($i === -2 && $check > '2') {
              ?>
              <li>…</li>
              <?php
            }
            if ($check >= 2 && $check <= $genelog_lastpage - 1) {
              if ($i === 0) {
                ?>
                <li class="current"><?php echo $check; ?></li>
                <?php
              } else {
              ?>
              <li><a href="?page=<?php echo $check; ?>"><?php echo $check; ?></a></li>
              <?php
  
              }
            } 
            if ($i === 2 && $check < $genelog_lastpage - 1) {
              ?>
              <li>…</li>
              <?php
            }
            if ($i === 0 && $this->genelog_page === $genelog_lastpage) {
              ?>
              <li class="current"><?php echo $genelog_lastpage; ?></li>
              <?php
            }
          }
        }
  
        if ($this->genelog_page < $genelog_lastpage) {
          ?>
          <li><a href="?page=<?php echo $genelog_lastpage; ?>"><?php echo $genelog_lastpage; ?></a></li>
          <li class="genelog_next"><a href="?page=<?php echo $this->genelog_page + 1; ?>"></a></li>
          <?php
        } elseif ($this->genelog_page == $genelog_lastpage) {
          ?>
          <li class="current"><?php echo $genelog_lastpage; ?></li>
          <?php
        }
  
        ?>
          
        </ul>
          <?php
      }
      
      }

}

?>